//  
//  Copyright (C) 2011 Ergo Developers
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using Gtk;

using Granite;
using Granite.Services;

using Ergo.Widgets;

namespace Ergo {

	public class ErgoApp : Granite.Application {
		
		public static int main (string[] args) {
			return new ErgoApp ().run (args);
		}
		       		
		private ErgoWindow window = null;
			
		public static SavedState saved_state { get; private set; default = null; }
				
		construct {
		
			// App info
			build_data_dir = Build.DATADIR;
			build_pkg_data_dir = Build.PKGDATADIR;
			build_release_name = Build.RELEASE_NAME;
			build_version = Build.VERSION;
			build_version_info = Build.VERSION_INFO;
			
			program_name = "Ergo";
			exec_name = "ergo";
			
			app_copyright = "2011";
			application_id = "net.launchpad.Ergo";
			app_icon = "ergo";
			app_launcher = "ergo.desktop";
			
			main_url = "https://launchpad.net/ergo";
			bug_url = "https://bugs.launchpad.net/ergo";
			help_url = "https://answers.launchpad.net/ergo";
			translate_url = "https://translations.launchpad.net/ergo";
			
			about_authors = {"Ergo Developers",	null};
			/*about_documenters = {"",
			null	
			};
			about_artists = {"",
			null	
			};*/
			about_translators = "Launchpad Translators";

			about_license = """Ergo is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ergo is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ergo. If not, see http://www.gnu.org/licenses""";
		}
		
		public ErgoApp () {
					
			// Set up settings
			saved_state = new SavedState ();
		}
		
		protected override void activate () {
			
			if (window != null) {
				window.present (); // present window if app is already open
				return;
			}
			
			window = new ErgoWindow (this);
			window.set_application (this);
			window.show_all ();		
		}
	
	}
	
}

