//  
//  Copyright (C) 2011 Ergo Developers
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using Gtk;
using Granite.Widgets;

using Ergo;
using Ergo.Backend;

namespace Ergo.Widgets {

	public class ErgoAddBar : Gtk.HBox {
	
		private ErgoWindow window;
		
		public HintedEntry entry_bar { get; private set; }

		public ErgoAddBar (ErgoWindow window) {
			this.window = window;

            // Initate
            entry_bar = new HintedEntry("Type a task...");
            // Setup
			pack_start(entry_bar, true, true, 0);
			
			//Callback
            entry_bar.activate.connect( () => add_button_callback());

		}
		
		public void add_button_callback() {
		     if (!(this.entry_bar.text == "Type a task..." || this.entry_bar.text == "" )) {
	             
                var db = new ErgoSqlBackend (this.window);
                var task_name = this.entry_bar.text;
                this.entry_bar.text = "";
                
                var notes = "No note specified";
                
                var today_date = new DateTime.now_local();
                int64 today = today_date.to_unix();
                today -= today % 86400;
                
                var task_list = 0; //default for now
                
                db.add_task(task_name, notes, today, task_list);
                this.window.tasks.update_model();
             }
		}
		
		
	}
	
}
        
