//  
//  Copyright (C) 2011 Ergo Developers
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using Gtk;
using Ergo;

namespace Ergo.Widgets {

	public class ErgoFolder : Gtk.Toolbar {
	
		private ErgoWindow window;
	
		public ErgoFolder (ErgoWindow window) {
		
			this.window = window;
			
			// Toolbar properties
			get_style_context ().add_class ("secondary-toolbar"); // compliant with elementary HIG
						
			// Initialize everything
			unowned GLib.SList<Gtk.RadioToolButton>? group = null;
			            			
			// ugly thing starts here ------------------------------------------
			
			string [] folders = new string[5];
			
			folders[0] = "All";
			folders[1] = "Today";
			folders[2] = "Tomorrow";
			folders[3] = "This week";
			folders[4] = "Later";
			
			foreach (var folder in folders)
			{
			    var button = folder_button (group, folder);
			    insert (button, -1);
			    group = button.get_group();
			}       
		}
		
        private Gtk.RadioToolButton folder_button (GLib.SList<Gtk.RadioToolButton>? group, string label) {

            // parameters with functions will come in there.
            var button = new Gtk.RadioToolButton (group);
            button.label = label;
            button.is_important = true;
            button.visible = true;
            button.clicked.connect (() => 
            {
                this.window.tasks.show_folder(label);
            });

            return button;
        }
        		
	}
	
}

