//  
//  Copyright (C) 2011 Ergo Developers
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using Gtk;

using Granite;
using Granite.Services;

using Ergo;

namespace Ergo.Widgets {

	public class ErgoMenu : Gtk.Menu {
	
		private ErgoWindow window;
			
		public CheckMenuItem fullscreen { get; private set; }

		public ErgoMenu (ErgoWindow window) {
		
			this.window = window;
		
			// Create everything
			fullscreen = new CheckMenuItem.with_label ("Fullscreen");
			fullscreen.active = ErgoApp.saved_state.window_state == ErgoWindowState.FULLSCREEN;
			
			// Append in correct order
			append (fullscreen);
			
			//TODO:
			
			// What AppMenu items do we need?
			
						
			// Callbacks
			fullscreen.toggled.connect (toggle_fullscreen);	
		}
		
		private void toggle_fullscreen () {
		
			if (fullscreen.active)
				window.fullscreen ();
			else
				window.unfullscreen ();
		}
	
	}

}
