//  
//  Copyright (C) 2011 Ergo Developers
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using Gtk;
using Granite.Widgets;

using Ergo;
using Ergo.Backend;

namespace Ergo.Widgets {

	public class ErgoSideBar : Gtk.VBox {
	
		private ErgoWindow window;
		
		public ErgoTaskList lists { get; private set; }
		public HintedEntry entry_bar { get; private set; }

		public ErgoSideBar (ErgoWindow window) {
			this.window = window;
            

            // Initate
            this.lists = new ErgoTaskList(this.window);
            this.entry_bar = new HintedEntry("Type a list name...");

            // Setup
            pack_start(this.entry_bar, false, false, 1);
            pack_start(this.lists, true, true, 1);
			
			//Callback
            this.entry_bar.activate.connect( () => add_callback());

		}
		
		public void add_callback() {
		     if (!(this.entry_bar.text == "Type a list name..." || this.entry_bar.text == "")) {
	             
                var db = new ErgoSqlBackend (this.window);
                var list_name = this.entry_bar.text;
                this.entry_bar.text = "";
                
                db.add_task_list(list_name);
                this.lists.update();
             }
		}
		
		
	}
	
}
        
