//  
//  Copyright (C) 2011 Ergo Developers
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using Gtk;
using Ergo;
using Ergo.Backend;

namespace Ergo.Widgets {

	public class ErgoTaskList : Gtk.TreeView {
	
	    public ListStore listmodel { get; public set; }
    
        public void add_task_list(int id, string list_name ,int tasks,  int tasks_done){
            
            TreeIter iter;
            listmodel.append(out iter); 
            listmodel.set(iter, 0, id, 1, list_name, 2, tasks, 3, tasks_done);
        }
        
        public void update(){
            listmodel.clear();
            window.backend.get_tasklists();
        }

        private ErgoWindow window;
        public int selected_tasklist = 0;
		public ErgoTaskList(ErgoWindow window) {
            
            this.window = window;
		    headers_visible = false;
		    //even_row_color = gtk.gdk.color_parse ( "#e9e9e9");
		    //odd_row_color = gtk.gdk.color_parse ( "#f3f3f3");
		

		    listmodel = new ListStore(4,		typeof(int),     	    // ID
		                                        typeof(string),     	// TaskList name
												typeof(int),     	// Tasks
												typeof(int)    	// Tasks done												
            );												
		    set_model(listmodel);
		    
			// Task name cloumn
	        insert_column_with_attributes(-1, "Task", new CellRendererText(), "text", 1);
	        	        
	        // Expander column
	        var column = new Gtk.TreeViewColumn();
            column.set_expand(true);
            insert_column(column, -1);
            
            
            // Remove column
            column = new Gtk.TreeViewColumn();
            var remove_pixbuf = new CellRendererPixbuf();
            /*//Removes
            remove_pixbuf.clicked.connect((path) => {
                //Delete row from backend -> refresh model
                print("\nDelete something\n");
			});
			//*/                        
            remove_pixbuf.stock_id = "gtk-close";
            column.pack_start (remove_pixbuf, false);
			insert_column(column, -1);
		}
	}
}

