    //  
//  Copyright (C) 2011 Ergo Developers
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using Gtk;
using Granite.Widgets;

using Ergo;
using Ergo.Backend;

namespace Ergo.Widgets {

	public class ErgoToolbar : Gtk.Toolbar {
	
		private ErgoWindow window;
		
		public ToolButton add_button { get; private set; }
		public ToolButton remove_done { get; private set; }		
//		public HintedEntry entry { get; private set; }
//		public DatePicker date_picker { get; private set; }
//		public TextView comment { get; private set; }
        public ErgoMenu menu { get; private set; }
		public AppMenu app_menu { get; private set; }
		public ToolItem spacer { get; private set; }
		public ToolItem searchbar { get; private set; }
		
		public ErgoToolbar (ErgoWindow window) {
		
			this.window = window;
			
			//
		//	this.date_picker = new DatePicker.with_format ("%a %e/%m");
			
			// Toolbar properties
			get_style_context ().add_class ("primary-toolbar"); // compliant with elementary HIG
			
			// Initialize everything
			add_button = make_toolbutton ("list-add", "Create a new task", true);
            remove_done = make_toolbutton ("list-remove", "Remove all done tasks", true);			
       /*     
            var add_pop = new Gtk.Button.with_label("Add");
            add_pop.halign = Gtk.Align.END;
            
            this.entry = new HintedEntry("Task...");
            
            add_pop.clicked.connect( () => add_button_callback());
            
            var label_pop = new Gtk.Label("Task/Event:");
            label_pop.halign = Gtk.Align.START;
            var label_notes = new Gtk.Label("Notes:");
            label_notes.halign = Gtk.Align.START;
            
            this.comment = new Gtk.TextView ();
			this.comment.height_request = 50;
         */   
			
			/*var pop = new Granite.Widgets.PopOver (null);
			pop.hbox.add(label_pop);
            pop.hbox.add(this.entry);
            pop.hbox.add(this.date_picker);
            pop.hbox.add(label_notes);
            pop.hbox.add(this.comment);
            pop.hbox.add(add_pop) ;
            add_button.clicked.connect( () => { pop.move_to(add_button); pop.show_all(); });
			*/
			
			spacer = make_spacer();

			var search = new SearchBar ("Type To Search...");
			searchbar = make_toolitem_from_widget (search);
	    	
			
            menu = new ErgoMenu(window);          
//            this.app_menu = new AppMenu(menu);
//            this.app_menu = (window.get_application() as Granite.Application).create_appmenu(menu);
            this.app_menu = window.app.create_appmenu(menu);
            // Insert into appropriate positions
			add(add_button);
			add(remove_done);
			add(spacer);		
			add(searchbar);
			add(this.app_menu);
			
			//Callback
            remove_done.clicked.connect( () =>  remove_done_callback());
		}
		
		private ToolButton make_toolbutton (string icon_name, string tooltip_text, bool sensitive = true,  bool can_focus = false) {
			
			var toolbutton = new ToolButton (null, null);
			toolbutton.icon_name = icon_name;
			toolbutton.sensitive = sensitive;
			toolbutton.can_focus = can_focus;
			toolbutton.tooltip_text = tooltip_text;
			
			return toolbutton;
		}
		
		
		private ToolItem make_spacer () {
			
			var spacer = new ToolItem ();
			spacer.set_expand (true);
			
			return spacer;
		}
		
		
		private ToolItem make_toolitem_from_widget (Widget widget) {
		
			var toolitem = new ToolItem ();
			toolitem.add (widget);
			
			return toolitem;
		}
	

		public void remove_done_callback() {
		    this.window.backend.remove_done();
		    this.window.tasks.update_model();
		}
/*		public void add_button_callback() {
		     print ("\nButton Pressed!");
		     if (this.entry.text != "Task...") {
	             
	             var db = new ErgoSqlBackend (this.window);
	             
	             var task_name = this.entry.text;
	             this.entry.text = "";
//		           var notes = this.comment.text;
                 var notes = "No notes for now";
	             var date = this.date_picker.date.to_unix();
	             var task_list = 0; //default for now
                 db.add_task(task_name, notes, date,task_list);
                 this.window.tasks.update_model();
                 db.get_all_in_tasklist(0);
             }
		}
*/		
		
	}
	
}

